<template>
  <div>
    <div class="hero is-primary">
      <div class="hero-body">
        <form class="login" @submit.prevent="handleLogin">
          <h1 class="title has-text-centered is-size-2">Sign in</h1>
          <div class="columns is-centered">
            <div class="column is-half">
              <div class="notification is-light">
                <figure class="image container is-64x64">
                  <img src="../assets/logo.png" />
                </figure>
                <div class="field">
                  <label class="label">email</label>
                  <p class="control has-icons-left has-icons-right">
                    <input
                      class="input"
                      required
                      v-model="user.email"
                      type="email"
                      placeholder="Email"
                    />
                    <span class="icon is-small is-left">
                      <font-awesome-icon icon="envelope" />
                    </span>
                  </p>
                </div>
                <div class="field">
                  <label class="label">Password:</label>
                  <p class="control has-icons-left">
                    <input
                      class="input"
                      v-model="user.password"
                      type="password"
                      placeholder="Password"
                    />
                    <span class="icon is-small is-left">
                      <font-awesome-icon icon="lock" />
                    </span>
                  </p>
                </div>
                <button
                  class="button is-primary is-rounded is-medium"
                  type="submit"
                >
                  Sign in
                </button>
              </div>
            </div>
          </div>
        </form>
        <router-link to="/register" class="router-link">
          <a class="button is-info">
            pas encore de compte ?
          </a></router-link
        >
      </div>
    </div>
  </div>
</template>

<script>
import User from "../models/user";

export default {
  name: "login",
  data: function() {
    return {
      user: new User("", ""),
      loading: false,
      message: ""
    };
  },
  computed: {
    loggedIn() {
      return this.$store.state.auth.status.loggedIn;
    }
  },
  created() {
    if (this.loggedIn) {
      //todo
      this.$router.push("/");
    }
  },

  methods: {
    handleLogin() {
      this.loading = true;
      this.$validator.validateAll().then(isValid => {
        if (!isValid) {
          this.loading = false;
          return;
        }
        if (this.user.email && this.user.password) {
          this.$store.dispatch("auth/login", this.user).then(
            () => {
              //todo
              this.$router.push("/");
            },
            error => {
              this.loading = false;
              this.message =
                (error.response && error.response.data) ||
                error.message ||
                error.toString();
            }
          );
        }
      });
    }
  }
};
</script>

<style type="text/css">
body {
  padding: 0;
  margin: 0;
}
.hero {
  height: 100vh;
  position: relative;
}
.notification {
  padding-top: 20px;
  padding-bottom: 30px;
}
.button {
  margin-top: 10px;
}
</style>
